########################################
# -*- coding:Utf-8 -*- 
########################################

import es, psyco, playerlib
psyco.full()

name_map = es.ServerVar("eventscripts_currentmap")
round_max_with_awp = es.ServerVar("round_max_avec_awp")
round_max_without_awp = es.ServerVar("round_max_sans_awp")
user_min = es.ServerVar("player_min_active")
maps_ext = es.ServerVar("extension_map_on")
limite_awp_team = es.ServerVar("awp_max_par_team")
commandprefix = es.ServerVar('eventscripts_cmdprefixes')

info = es.AddonInfo()
info.name = "Limite AWP Python"
info.author = "EmbouT et Sylv@in."

# Création variable version
version_addons_limite_awp = es.ServerVar("addons_Python_Limite_AWP", "1.6.14")
# attribution de la valeur (au cas où celle si existe deja)
version_addons_limite_awp.set("1.6.14")
# la rendre plublic
version_addons_limite_awp.makepublic()

# ####################
# CONFIG
# #################### 

def config(M):
    
    global script
    script = {"activate" : 0, "buy awp" : [], "possede awp" : [], "avec awp" : {}, "sans awp" : {}}
    es.server.cmd("es_xmexec ../addons/eventscripts/limite_awp/limite_awp.cfg")

    if M.split("_")[0] in str(maps_ext):
        script['activate'] = 1
    else:
        script['activate'] = 0

# ####################
# LOAD
# ####################

def load():

    config(str(name_map))
    if 'd' not in str(commandprefix):
        commandprefix.set(str(commandprefix) + 'd')
    if 'b' not in str(commandprefix):
        commandprefix.set(str(commandprefix) + 'b')

# ####################
# ITEM PICKUP
# ####################

def item_pickup(ev):

    global script, nbr_awp_terro, nbr_awp_ct
    if script['activate']:
        # Si l'arme ramassée est un AWP
        if ev['item'] == "awp":
            script['possede awp'].append(ev['userid'])
            # Si il n'y a pas assez de joueur, on lui enlève l'AWP
            if nombre_reel_joueur() < int(user_min):
                remove_awp(ev['userid'])
                script['possede awp'].remove(ev['userid'])
                es.msg ("#multi", "#green[LIMITATION AWP]==>#lightgreen Il faut #default"+str(user_min)+"#lightgreen joueurs pour prendre #defaultl'AWP !!!")
            # Si il y a assez de joueurs
            else:
                # Si le joueur est TERRO
                if ev['es_userteam'] == "2":
                    nbr_awp_terro = nbr_awp_terro + 1
                    # Si le nombre de Snipe en TERRO dépasse la limite fixée, on lui enlève
                    if nbr_awp_terro > int(limite_awp_team):
                        nbr_awp_terro = nbr_awp_terro - 1
                        remove_awp(ev['userid'])
                        script['possede awp'].remove(ev['userid'])
                        es.msg ("#multi", "#green[LIMITATION AWP]==> #lightgreenIl ne peut y avoir que #default"+str(limite_awp_team)+"#lightgreen AWP par Team")
                    # Si le joueur n'a pas atteind son quota de round AVEC AWP,  on lui laisse et on augmente son nombre de round avec AWP de 1
                    if script['avec awp'][ev['userid']] < int(round_max_with_awp):
                        script['avec awp'][ev['userid']] += 1
                    # Si le joueur a fait son quota de round AVEC AWP
                    else:
                        # Si le joueur n'a pas fait son quota de round SANS AWP
                        if script['sans awp'][ev['userid']] < int(round_max_without_awp):
                            nbr_awp_terro = nbr_awp_terro - 1
                            remove_awp(ev['userid'])
                            script['possede awp'].remove(ev['userid'])
                            es.msg ("#multi", "#green[LIMITATION AWP]==> #default"+str(ev['es_username'])+"#lightgreen doit lacher son AWP !!!")
                        # Si le joueur a fait son quote de round SANS AWP et AVEC AWP on remet ses compteurs à zéro
                        else:
                            script['avec awp'][ev['userid']] = 0
                            script['sans awp'][ev['userid']] = 0
                # Le joueur est CT
                elif ev['es_userteam'] == "3":
                    nbr_awp_ct = nbr_awp_ct + 1
                    # Si le nombre de Snipe en TERRO dépasse la limite fixée, on lui enlève
                    if nbr_awp_ct > int(limite_awp_team):
                        nbr_awp_ct = nbr_awp_ct - 1
                        remove_awp(ev['userid'])
                        script['possede awp'].remove(ev['userid'])
                        es.msg ("#multi", "#green[LIMITATION AWP]==> #lightgreenIl ne peut y avoir que #default"+str(limite_awp_team)+"#lightgreen AWP par Team")
                    # Si le joueur n'a pas atteind son quota de round AVEC AWP,  on lui laisse et on augmente son nombre de round avec AWP de 1
                    if script['avec awp'][ev['userid']] < int(round_max_with_awp):
                        script['avec awp'][ev['userid']] += 1
                    # Si le joueur a fait son quota de round AVEC AWP
                    else:
                        # Si le joueur n'a pas fait son quota de round SANS AWP
                        if script['sans awp'][ev['userid']] < int(round_max_without_awp):
                            nbr_awp_ct = nbr_awp_ct - 1
                            remove_awp(ev['userid'])
                            script['possede awp'].remove(ev['userid'])
                            es.msg ("#multi", "#green[LIMITATION AWP]==> #default"+str(ev['es_username'])+"#lightgreen doit lacher son AWP !!!")
                        # Si le joueur a fait son quote de round SANS AWP et AVEC AWP on remet ses compteurs à zéro
                        else:
                            script['avec awp'][ev['userid']] = 0
                            script['sans awp'][ev['userid']] = 0

# ####################
# PLAYER SPAWN
# ####################

def player_spawn(ev):

    global script, nbr_awp_terro, nbr_awp_ct
    if script['activate']:
        if not es.getplayerprop(ev['userid'], "CBasePlayer.pl.deadflag"):
            #Si le joueur n'a PAS L'AWP
            if ev['userid'] not in script['possede awp']:
                # Si Le joueur a atteint son cota de round avec AWP
                if script['avec awp'][ev['userid']] == int(round_max_with_awp):
                    # on rajoute un round sans AWP
                    script['sans awp'][ev['userid']] += 1
                    # Si le joueur a fait assez de round sans AWP
                    if script['sans awp'][ev['userid']] > int(round_max_without_awp):
                        # on remet ses compteurs à 0
                        script['sans awp'][ev['userid']] = 0
                        script['avec awp'][ev['userid']] = 0
            # Si le joueur a l'AWP
            else:
                # Si il n'y a pas assez de joueur, on lui enlève l'AWP
                if nombre_reel_joueur() < int(user_min):
                    remove_awp(ev['userid'])
                    script['possede awp'].remove(ev['userid'])
                    es.msg ("#multi", "#green[LIMITATION AWP]==>#lightgreen Il faut #default"+str(user_min)+"#lightgreen joueurs pour prendre #defaultl'AWP !!!")
                # Si il y a assez de joueurs
                else:
                    # Si le joueur est TERRO
                    if ev['es_userteam'] == "2":
                        nbr_awp_terro = nbr_awp_terro + 1
                        # Si le nombre de Snipe en TERRO dépasse la limite fixée, on lui enlève
                        if nbr_awp_terro > int(limite_awp_team):
                            nbr_awp_terro = nbr_awp_terro - 1
                            remove_awp(ev['userid'])
                            script['possede awp'].remove(ev['userid'])
                            es.msg ("#multi", "#green[LIMITATION AWP]==> #lightgreenIl ne peut y avoir que #default"+str(limite_awp_team)+"#lightgreen AWP par Team")
                        # Si le joueur n'a pas atteind son quota de round AVEC AWP,  on lui laisse et on augmente son nombre de round avec AWP de 1
                        if script['avec awp'][ev['userid']] < int(round_max_with_awp):
                            script['avec awp'][ev['userid']] += 1
                        # Si le joueur a fait son quota de round AVEC AWP
                        else:
                            # Si le joueur n'a pas fait son quota de round SANS AWP
                            if script['sans awp'][ev['userid']] < int(round_max_without_awp):
                                nbr_awp_terro = nbr_awp_terro - 1
                                remove_awp(ev['userid'])
                                script['possede awp'].remove(ev['userid'])
                                es.msg ("#multi", "#green[LIMITATION AWP]==> #default"+str(ev['es_username'])+"#lightgreen doit lacher son AWP !!!")
                            # Si le joueur a fait son quote de round SANS AWP et AVEC AWP on remet ses compteurs à zéro
                            else:
                                script['avec awp'][ev['userid']] = 0
                                script['sans awp'][ev['userid']] = 0
                    # Le joueur est CT
                    elif ev['es_userteam'] == "3":
                        nbr_awp_ct = nbr_awp_ct + 1
                        # Si le nombre de Snipe en TERRO dépasse la limite fixée, on lui enlève
                        if nbr_awp_ct > int(limite_awp_team):
                            nbr_awp_ct = nbr_awp_ct - 1
                            remove_awp(ev['userid'])
                            script['possede awp'].remove(ev['userid'])
                            es.msg ("#multi", "#green[LIMITATION AWP]==> #lightgreenIl ne peut y avoir que #default"+str(limite_awp_team)+"#lightgreen AWP par Team")
                        # Si le joueur n'a pas atteind son quota de round AVEC AWP,  on lui laisse et on augmente son nombre de round avec AWP de 1
                        if script['avec awp'][ev['userid']] < int(round_max_with_awp):
                            script['avec awp'][ev['userid']] += 1
                        # Si le joueur a fait son quota de round AVEC AWP
                        else:
                            # Si le joueur n'a pas fait son quota de round SANS AWP
                            if script['sans awp'][ev['userid']] < int(round_max_without_awp):
                                nbr_awp_ct = nbr_awp_ct - 1
                                remove_awp(ev['userid'])
                                script['possede awp'].remove(ev['userid'])
                                es.msg ("#multi", "#green[LIMITATION AWP]==> #default"+str(ev['es_username'])+"#lightgreen doit lacher son AWP !!!")
                            # Si le joueur a fait son quote de round SANS AWP et AVEC AWP on remet ses compteurs à zéro
                            else:
                                script['avec awp'][ev['userid']] = 0
                                script['sans awp'][ev['userid']] = 0

# ####################
# MAP START
# ####################

def es_map_start(ev):

    global nbr_awp_terro, nbr_awp_ct, script
    config(ev['mapname'])
    nbr_awp_terro = 0
    nbr_awp_ct = 0
    del(script['buy awp'][:])

# ####################
# PLAYER ACTIVATE
# ####################

def player_activate(ev):

    global script
    script['avec awp'][ev['userid']] = 0
    script['sans awp'][ev['userid']] = 0

# ####################
# LE JOUEUR MEURT
# ####################

def player_death(ev):
    
    global script, nbr_awp_ct, nbr_awp_terro
    # Si le joueur qui meurt est dans la base, on réduit le nbre d'AWP de sa Team de 1
    if ev['userid'] in script['possede awp']:
        if ev['es_userteam'] == "3":
            nbr_awp_ct = nbr_awp_ct - 1
        if ev['es_userteam'] == "2":
           nbr_awp_terro = nbr_awp_terro - 1
        script['possede awp'].remove(ev['userid'])

# ####################
# ROUND END
# ####################

def round_end(ev):
    
    global script, nbr_awp_terro, nbr_awp_ct
    nbr_awp_ct = 0
    nbr_awp_terro = 0
    del(script['buy awp'][:])

# ####################
# CLIENT COMMAND
# ####################

def es_client_command(ev):
    
    global nbr_awp_terro, nbr_awp_ct, script
    # Si le joueur DROP un AWP, on réduit de 1 le Nombre d'AWP de sa Team
    if ev['command'] == "drop":
        if playerlib.getPlayer(ev['userid']).get("primary") != "awp":
            if ev['userid'] in script['possede awp']:
                if ev['es_userteam'] == "3":
                    nbr_awp_ct = nbr_awp_ct - 1
                if ev['es_userteam'] == "2":
                    nbr_awp_terro = nbr_awp_terro - 1
                script['possede awp'].remove(ev['userid'])
    # Si le joueur achète un AWP
    if ev['command'] == "buy" and ev['commandstring'] == "awp":
        script['buy awp'].append(ev['userid'])
            
# ##############################################################
#                                                            DEFINITION DES FONCTIONS                                                                  #
# ##############################################################

# ####################
# NOMBRE REEEL DE JOUEURS
# ####################

def nombre_reel_joueur():
    
    return len(playerlib.getUseridList('#ct')) + len(playerlib.getUseridList('#t'))

# ####################
# REMOVE AWP
# ####################

def remove_awp(userid):
    
    global script
    # On récupère les infos du joueur
    player = playerlib.getPlayer(userid)
    
    # On drop son AWP
    es.server.queuecmd("es_xremove %s" % player.get("weaponindex", "awp"))
    es.sexec(userid, "use weapon_knife")
    #Si le joueur est dans la zone d'achat et qu'il fait partie des joueurs ayant acheté un AWP
    if player.get('inbuyzone') and userid in script['buy awp']:
        # on modifie son argent
        cash_player = player.get("cash") + 4750
        # Si la réserve d'argent du joueur ne dépasse pas 16000 on le rembourse
        if cash_player <= 16000:
            player.set("cash", cash_player)
        # Sinon on fixe sa réserve à 16000
        else:
            player.set("cash", 16000)
        # On le retire de la liste
        script['buy awp'].remove(userid)
